###################################################
### chunk number 1: 
###################################################
#line 20 "viewports.Snw"
library(grDevices)
library(stats) # for runif()
library(grid)
ps.options(pointsize = 12)
options(width = 60)


###################################################
### chunk number 2: 
###################################################
#line 44 "viewports.Snw"
pushViewport(viewport())
upViewport()
pushViewport(viewport())


###################################################
### chunk number 3: 
###################################################
#line 62 "viewports.Snw"
grid.newpage()



###################################################
### chunk number 4: 
###################################################
#line 65 "viewports.Snw"
pushViewport(viewport(name = "A"))
upViewport()
pushViewport(viewport(name = "B"))
upViewport()
downViewport("A")


###################################################
### chunk number 5: 
###################################################
#line 79 "viewports.Snw"
seekViewport("B")


###################################################
### chunk number 6: 
###################################################
#line 85 "viewports.Snw"
current.vpTree()



###################################################
### chunk number 7: vpstackguts
###################################################
#line 105 "viewports.Snw"
vp <- viewport(width = 0.5, height = 0.5)
grid.rect(vp = vpStack(vp, vp))


###################################################
### chunk number 8: 
###################################################
#line 108 "viewports.Snw"
grid.rect(gp = gpar(col = "grey"))
#line 105 "viewports.Snw"
vp <- viewport(width = 0.5, height = 0.5)
grid.rect(vp = vpStack(vp, vp))
#line 110 "viewports.Snw"


###################################################
### chunk number 9: 
###################################################
#line 134 "viewports.Snw"
grid.newpage()



###################################################
### chunk number 10: 
###################################################
#line 137 "viewports.Snw"
pushViewport(viewport(name = "A"))
pushViewport(viewport(name = "B"))
pushViewport(viewport(name = "A"))


###################################################
### chunk number 11: 
###################################################
#line 146 "viewports.Snw"
seekViewport("A")
current.vpTree(FALSE)


###################################################
### chunk number 12: 
###################################################
#line 153 "viewports.Snw"
seekViewport(vpPath("B", "A"))
current.vpTree(FALSE)


###################################################
### chunk number 13: 
###################################################
#line 160 "viewports.Snw"
vpPath("A", "B")


###################################################
### chunk number 14:  eval=FALSE
###################################################
## #line 168 "viewports.Snw"
## seekViewport(vpPath("A", "B"))
## seekViewport("A::B")


###################################################
### chunk number 15: 
###################################################
#line 179 "viewports.Snw"
x <- runif(10)
y <- runif(10)


###################################################
### chunk number 16: 
###################################################
#line 186 "viewports.Snw"
xscale <- extendrange(x)
yscale <- extendrange(y)


###################################################
### chunk number 17: 
###################################################
#line 197 "viewports.Snw"
top.vp <-
    viewport(layout=grid.layout(3, 3,
             widths=unit(c(5, 1, 2), c("lines", "null", "lines")),
             heights=unit(c(5, 1, 4), c("lines", "null", "lines"))))



###################################################
### chunk number 18: 
###################################################
#line 203 "viewports.Snw"
grid.show.layout(viewport.layout(top.vp))


###################################################
### chunk number 19: 
###################################################
#line 211 "viewports.Snw"
margin1 <- viewport(layout.pos.col = 2, layout.pos.row = 3,
                    name = "margin1")
margin2 <- viewport(layout.pos.col = 1, layout.pos.row = 2,
                    name = "margin2")
margin3 <- viewport(layout.pos.col = 2, layout.pos.row = 1,
                    name = "margin3")
margin4 <- viewport(layout.pos.col = 3, layout.pos.row = 2,
                    name = "margin4")
plot <- viewport(layout.pos.col = 2, layout.pos.row = 2,
                 name = "plot", xscale = xscale, yscale = yscale)


###################################################
### chunk number 20: 
###################################################
#line 228 "viewports.Snw"
splot <- vpTree(top.vp, vpList(margin1, margin2, margin3, margin4, plot))


###################################################
### chunk number 21: viewports
###################################################
#line 236 "viewports.Snw"
pushViewport(splot)


###################################################
### chunk number 22: grid eval=FALSE
###################################################
## #line 243 "viewports.Snw"
## labelvp <- function(name) {
##     seekViewport(name)
##     grid.rect(gp = gpar(col = "grey", lwd = 5))
##     grid.rect(x = 0, y = 1, width = unit(1, "strwidth", name) + unit(2, "mm"),
##               height = unit(1, "lines"), just = c("left", "top"),
##               gp = gpar(fill = "grey", col = NULL))
##     grid.text(name, x = unit(1, "mm"), y = unit(1, "npc") - unit(1, "mm"),
##               just = c("left", "top"), gp = gpar(col = "white"))
## }
## labelvp("plot")
## labelvp("margin1")
## labelvp("margin2")
## labelvp("margin3")
## labelvp("margin4")


###################################################
### chunk number 23: plot eval=FALSE
###################################################
## #line 261 "viewports.Snw"
## seekViewport("plot")
## grid.points(x, y)
## grid.xaxis()
## grid.yaxis()
## grid.rect()


###################################################
### chunk number 24: margin1 eval=FALSE
###################################################
## #line 270 "viewports.Snw"
## seekViewport("margin1")
## grid.text("Random X", y = unit(1, "lines"))


###################################################
### chunk number 25: margin2 eval=FALSE
###################################################
## #line 277 "viewports.Snw"
## seekViewport("margin2")
## grid.text("Random Y", x = unit(1, "lines"), rot = 90)
## 


###################################################
### chunk number 26: 
###################################################
#line 281 "viewports.Snw"
pushViewport(viewport(w = 0.9, h = 0.9))
#line 236 "viewports.Snw"
pushViewport(splot)
#line 283 "viewports.Snw"
#line 243 "viewports.Snw"
labelvp <- function(name) {
    seekViewport(name)
    grid.rect(gp = gpar(col = "grey", lwd = 5))
    grid.rect(x = 0, y = 1, width = unit(1, "strwidth", name) + unit(2, "mm"),
              height = unit(1, "lines"), just = c("left", "top"),
              gp = gpar(fill = "grey", col = NULL))
    grid.text(name, x = unit(1, "mm"), y = unit(1, "npc") - unit(1, "mm"),
              just = c("left", "top"), gp = gpar(col = "white"))
}
labelvp("plot")
labelvp("margin1")
labelvp("margin2")
labelvp("margin3")
labelvp("margin4")
#line 284 "viewports.Snw"
#line 261 "viewports.Snw"
seekViewport("plot")
grid.points(x, y)
grid.xaxis()
grid.yaxis()
grid.rect()
#line 285 "viewports.Snw"
#line 270 "viewports.Snw"
seekViewport("margin1")
grid.text("Random X", y = unit(1, "lines"))
#line 286 "viewports.Snw"
#line 277 "viewports.Snw"
seekViewport("margin2")
grid.text("Random Y", x = unit(1, "lines"), rot = 90)

#line 287 "viewports.Snw"


###################################################
### chunk number 27: 
###################################################
#line 301 "viewports.Snw"
upViewport(0)


###################################################
### chunk number 28: annguts eval=FALSE
###################################################
## #line 315 "viewports.Snw"
## seekViewport("margin3")
## grid.text("The user adds a title!", gp = gpar(fontsize = 20))
## 


###################################################
### chunk number 29: 
###################################################
#line 319 "viewports.Snw"
pushViewport(viewport(w = 0.9, h = 0.9))
#line 236 "viewports.Snw"
pushViewport(splot)
#line 321 "viewports.Snw"
#line 243 "viewports.Snw"
labelvp <- function(name) {
    seekViewport(name)
    grid.rect(gp = gpar(col = "grey", lwd = 5))
    grid.rect(x = 0, y = 1, width = unit(1, "strwidth", name) + unit(2, "mm"),
              height = unit(1, "lines"), just = c("left", "top"),
              gp = gpar(fill = "grey", col = NULL))
    grid.text(name, x = unit(1, "mm"), y = unit(1, "npc") - unit(1, "mm"),
              just = c("left", "top"), gp = gpar(col = "white"))
}
labelvp("plot")
labelvp("margin1")
labelvp("margin2")
labelvp("margin3")
labelvp("margin4")
#line 322 "viewports.Snw"
#line 261 "viewports.Snw"
seekViewport("plot")
grid.points(x, y)
grid.xaxis()
grid.yaxis()
grid.rect()
#line 323 "viewports.Snw"
#line 270 "viewports.Snw"
seekViewport("margin1")
grid.text("Random X", y = unit(1, "lines"))
#line 324 "viewports.Snw"
#line 277 "viewports.Snw"
seekViewport("margin2")
grid.text("Random Y", x = unit(1, "lines"), rot = 90)

#line 325 "viewports.Snw"
#line 315 "viewports.Snw"
seekViewport("margin3")
grid.text("The user adds a title!", gp = gpar(fontsize = 20))

#line 326 "viewports.Snw"
popViewport(0)


